/* --------------------------------------------------------------------------
 * BreakOut
 * --------------------------------------------------------------------------
 * prog:  Max Rheiner 
 * date:  26/09/2012 (m/d/y)
 * ----------------------------------------------------------------------------
 */

import ddf.minim.*;  // import und name für library

Minim minim;
AudioSample ballHitSnd;   // sound den man hört
AudioSample ballHitSchlaegerSnd;
AudioSample hpMenu;
AudioSample hpLevelup;
AudioSample hpTod;
AudioSample hpm;

BouncingBall ball;
Racket       schlaeger = null;
Brick[]      brickList = null; //array wegen klammer


final static int GAME_MODE_MENU      = 0;   //macht read only - 3 verschiedene mondi
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;
final static int GAME_MODE_LEVELFINISHED  = 3;


int          gameMode = GAME_MODE_MENU;
PImage       homingpigeonsstart;
PImage       homingpigeonsgame;
PImage       homingpigeonstod;
PImage       homingpigeonsfinished;

boolean      flagTime;
int          counterStartTime;
int          counter = 100;
PFont        font;
String       time = "010";

void setup() 
{
  size(1200, 800); 
  
  homingpigeonsstart = loadImage("homingpigeonsstart.jpg");
  homingpigeonstod = loadImage("homingpigeonstod.jpg");
  homingpigeonsgame = loadImage("homingpigeonsgame.jpg");
  homingpigeonsfinished = loadImage("homingpigeonsfinished.jpg");
  
  font = createFont("Arial", 30);

  ball = new BouncingBall(width/2, height/2, 10);

  schlaeger = new Racket(0, height - 40, 150, 80);   

  // sound init
  minim = new Minim(this); // this -> verweis auf unsere klasse, einfach so schreiben
  ballHitSnd = minim.loadSample("hit.mp3");
  ballHitSchlaegerSnd = minim.loadSample("hitSchlaeger.mp3");
  hpMenu = minim.loadSample("hpMenu.mp3");
  hpLevelup = minim.loadSample("hpLevelup.mp3");
  hpTod = minim.loadSample("hpTod.mp3");
  hpm = minim.loadSample("hpm.mp3");
  
  hpm.stop();
  hpMenu.trigger();
  
  smooth();
  noCursor();
}

void initGameScene() // funktion kreiert zufällig ein neues spielfeld
{

  // setzte die start posititon des balles
  ball.set(new PVector(width/2, height/2), new PVector(random(-5, 5), -5), 1); //ball immer mitte, aber ausrichtung nicht

  // erzeuge die ziegel
  brickList = new Brick[(15)]; //schleife durch ziegelsteinde, anzahl random (3,12)
  //  for (int i=0;i < brickList.length;i++)
  {
    int wbrief = 60;
    int hbrief = 50;
    
    brickList[0] = new Brick(200, 450, wbrief, hbrief);
    brickList[1] = new Brick(400, 450, wbrief, hbrief);
    brickList[2] = new Brick(600, 450, wbrief, hbrief);
    brickList[3] = new Brick(800, 450, wbrief, hbrief);
    brickList[4] = new Brick(1000, 450, wbrief, hbrief);
    brickList[6] = new Brick(300, 400, wbrief, hbrief);
    brickList[7] = new Brick(500, 400, wbrief, hbrief);
    brickList[8] = new Brick(700, 400, wbrief, hbrief);
    brickList[9] = new Brick(900, 400, wbrief, hbrief);
    brickList[10] = new Letterbox(700, 300, 50, 75);
    brickList[11] = new Letterbox(500, 300, 50, 75);
    brickList[12] = new Letterbox(600, 600, 50, 75);
    brickList[13] = new Poison(200, 50, 20, 50);
    brickList[14] = new Poison(1000, 50, 20, 50);
  }
  
}


void draw()
{
  // ghosting
  image(homingpigeonsgame,0,0);
  counterStartTime = millis();
  /*
  fill(0,0,0, 120);
  rect(0, 0, width, height);
*/
  drawScene(); //Scene ist funktion, kann 3 möglichkeiten haben (modi) oben
}

void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  case GAME_MODE_LEVELFINISHED:
    drawLevelFinished();
    break;
  }
}
 

void drawMenu()
{
  hpm.stop();
  pushStyle();
 // fill(255);
 // text("Homing Pigeons", 550, 510);  
 // text("\'p\' : start game", 550, 530);  
 // text("Space : stop game", 550, 550);
  image(homingpigeonsstart,0,0);;  
  popStyle();
}

void drawGameOver()
{  
  hpm.stop();
  pushStyle();
// fill(255);
// text("Game Over", 550, 200);
  image(homingpigeonstod,0,0);  
  popStyle();
}

void drawLevelFinished ()
{
  hpm.stop();
  pushStyle();
 // fill(255);
 // text("Level Finished", 550, 200);
  image(homingpigeonsfinished,0,0);  
  popStyle();
}


void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();

  // zeichne ziegel
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
      brickList[i].draw();
  }

  // zeichne den ball
  ball.draw();

  // zeichne schlaeger
  schlaeger.draw();
}

void keyPressed()
{
  switch(key)
  {
  case 'p':
    // start game
    gameMode = GAME_MODE_PLAY;
    hpm.stop();
    hpMenu.stop();
    hpTod.stop();
    hpm.trigger();
    initGameScene();
    break;
  case ' ': //space, spiel abbrechen -> anfangsbildschirm
    // end
    gameMode = GAME_MODE_MENU;
    hpMenu.trigger();
    hpm.stop();
    break;
  }
}

void  updateScene() // herz und logik des spiels
{
  // test ob ball aus dem spielfeld ist
  if (ball._pos.y > height- ball._r || (counter == 0 && flagTime == true))
  {
    gameMode = GAME_MODE_GAMEOVER;
    hpTod.trigger();
    return;
  }
  
  
     boolean endFlag = true;
    for (int q = 0; q < brickList.length; q++) {
         if (brickList[q] != null) {
           if(brickList[q].typ < 2) {
             endFlag = false;
           }
         }
 }
  
 if (endFlag == true) {
 if (ball._pos.y < 50 && ball._pos.x > 500 && ball._pos.x < 700)
  {
    gameMode = GAME_MODE_LEVELFINISHED;
    hpLevelup.trigger();
    return;
  }
 }
  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);
  
  PVector hitPos = new PVector();
  float  hitV;
  float  speed;
  
  // teste ob ball den schlaeger trifft
  int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
  switch(retVal)
  {
  case Brick.HIT_LEFT:
     // aendere flugrichtung ball
    ball._dir.x *= -1; // wenn links getroffen wurde nur x geändert
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x - schlaeger._w/2 - ball._r;
    
    // spiele sound -> wenn schläger getroffen wird
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_RIGTH:
     // aendere flugrichtung ball
    ball._dir.x *= -1;
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x + schlaeger._w/2 + ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_TOP:
     // aendere flugrichtung ball
    
    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y - schlaeger._h/2 - ball._r ;
    
    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break; 
  case Brick.HIT_BOTTOM:
    // aendere flugrichtung ball
    
    // anschnitt berechnen 
     hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y + schlaeger._h/2 + ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  }
  
  // test ob ball einen ziegel trifft
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null) //null getroffen, nicht mehr zeichnen
    {
      retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
      switch(retVal)
      {
      case Brick.HIT_LEFT:
      case Brick.HIT_RIGTH:
        // aendere flugrichtung ball
        ball._dir.x *= -1;

        // entferne ziegel aus liste
        if (brickList[i].typ!=1)
          brickList[i] = null;
         else
         {
           Letterbox letterB = (Letterbox)brickList[i];
           
           if(letterB.zaehler > 0) {
             letterB.zaehler --;
             
             
             
           } else {brickList[i] = null;}
         }
        
        // entferne ziehel aus liste & countdown von 100 bis null wenn giftflasche getroffen wird
    /*    if (brickList[i].typ == 0) 
        {
          brickList[i] = null;
        }
        else if (brickList[i].typ == 1)
        {
           Letterbox letterB = (Letterbox)brickList[i];
           
           if(letterB.zaehler > 0) {
             letterB.zaehler --;
             
           } else {brickList[i] = null;}
            
        } else if (brickList[i].typ == 2) {
          
            Poison letterC = (Poison)brickList[i];
            
            if(flagTime == true){
              counter=100-(millis()-counterStartTime)/1000;
              brickList[i] = null;
            
              flagTime = true;
              counterStartTime = millis();}    
        }*/
        // spiele sound
        ballHitSnd.trigger();
        break;
      case Brick.HIT_TOP:
      case Brick.HIT_BOTTOM:
        // aendere flugrichtung ball
        ball._dir.y *= -1;

        // entferne ziegel aus liste
        if (brickList[i].typ!=1)
          brickList[i] = null;
         else
         {
           Letterbox letterB = (Letterbox)brickList[i];
           
           if(letterB.zaehler > 0) {
             letterB.zaehler --;
             
             
             
           } else {brickList[i] = null;}
         }

        // spiele sound
        ballHitSnd.trigger();
        break;
      }
    }
  }
}





